/******************************************************************************/
// If you change one of the following settings, do not forget to recompile
// the plugin and to install the new .amx file on your server.
// You can find the list of admin flags in the amx/examples/include/amxconst.inc file.

#define FLAG_AMX_HSMODE ADMIN_CVAR

// Uncomment the following line to enable the AMX logs for this plugin.
//#define USE_LOGS

/******************************************************************************/

#include <translator>
#include <amxmod>
#include <amxmisc>
#include <VexdUM>

#define IsPlayer(%1)  (1 <= %1 <= g_maxplayers)

new bool:g_enabled
new g_cvar_hsonly_mode
new g_cvar_hsonly_mode_infomsg
new g_maxplayers

public plugin_init() {
  load_translations("hsonly_mod")
  register_plugin(_T("HeadShot Only Mod"), "1.1", "Gilly/Fl@ToUneT")
  register_concmd("amx_hsmode", "cmdHsmode", FLAG_AMX_HSMODE, _T("<0|1> - disables/enables ^"HeadShot Only^" mode"))

  g_cvar_hsonly_mode = register_cvar("hsonly_mode", "0")
  g_cvar_hsonly_mode_infomsg = register_cvar("hsonly_mode_infomsg", "1")

  register_logevent("newround", 2, "1=Round_Start")

  g_maxplayers = get_maxplayers()
  set_task(8.0, "initialize_mod", 8956421)
}

public initialize_mod() {
  g_enabled = (get_cvarptr_num(g_cvar_hsonly_mode) > 0) ? true : false
}

public newround() {
  if((g_enabled = bool:(get_cvarptr_num(g_cvar_hsonly_mode) > 0)) == true && get_cvarptr_num(g_cvar_hsonly_mode_infomsg) > 0)
    client_print_color_all_light(_T("[^4AMX Mod^1] ^"^3HeadShot Only^1^" mode is enabled!"))
}

public cmdHsmode(id, level, cid) {
  if(!cmd_access(id, level, cid, 2)) {
    return PLUGIN_HANDLED
  }

  new arg[2]
  read_argv(1, arg, charsmax(arg))
  new bool:status = (get_cvarptr_num(g_cvar_hsonly_mode) > 0) ? true : false
  g_enabled = status

  if(arg[0] == '1') {
    if(status) {
      console_print(id, _T("^"HeadShot Only^" mode is already enabled!"))
      return PLUGIN_HANDLED
    }

    set_cvarptr_string(g_cvar_hsonly_mode, "1")
    g_enabled = true
    console_print(id, _T("You enabled ^"HeadShot Only^" mode."))
    client_print_color_all_light(_T("[^4AMX Mod^1] ^"^3HeadShot Only^1^" mode has been enabled!"))
  }
  else if(arg[0] == '0') {
    if(!status) {
      console_print(id, _T("^"HeadShot Only^" mode is already disabled!"))
      return PLUGIN_HANDLED
    }

    set_cvarptr_string(g_cvar_hsonly_mode, "0")
    g_enabled = false
    console_print(id, _T("You disabled ^"HeadShot Only^" mode."))
    client_print_color_all_light(_T("[^4AMX Mod^1] ^"^3HeadShot Only^1^" mode has been disabled!"))
  }
  else {
    console_print(id, _T("Usage: amx_hsmode <0|1> - disables/enables ^"HeadShot Only^" mode (currently: %s)"),
    status ? _T("Enabled") : _T("Disabled"))
  }

  #if defined USE_LOGS
  if(g_enabled != status && get_gametime() > 8.0) { // won't log at map change
    if(id == 0) {
      log_amx("HeadShot Only Mod: <SERVER> %s ^"HeadShot Only^" mode.", g_enabled ? "enable" : "disable")
    }
    else {
      new szAdminName[32], szAdminAuthid[24], szAdminIpAddress[24]
      get_user_name(id, szAdminName, charsmax(szAdminName))
      get_user_authid(id, szAdminAuthid, charsmax(szAdminAuthid))
      get_user_ip(id, szAdminIpAddress, charsmax(szAdminIpAddress), 1)
      log_amx("HeadShot Only Mod: ^"<%s><%d><%s><%s>^" %s ^"HeadShot Only^" mode.",
      szAdminName, get_user_userid(id), szAdminAuthid, szAdminIpAddress, g_enabled ? "enable" : "disable")
    }
  }
  #endif

  return PLUGIN_HANDLED 
}

public traceline(entity) {
  if(g_enabled/* || get_cvarptr_num(g_cvar_hsonly_mode)*/) {
    if(IsPlayer(entity) && is_user_alive(entity)) {
      new entity2 = traceline_get_edict(TR_ENT_pHit)
      if(IsPlayer(entity2) && is_user_alive(entity2)) {
        if(traceline_get_int(TR_INT_iHitgroup) != HIT_HEAD) {
          traceline_set_float(TR_FL_flFraction, 1.0)
          return PLUGIN_HANDLED
        }
      }
    }
  }
  return PLUGIN_CONTINUE
}

client_print_color_all_light({Float,_}:...) {
  static szMessage[192]
  static iMsgIdSayText
  szMessage[0] = 0x01

  if(iMsgIdSayText == 0) {
    iMsgIdSayText = get_user_msgid("SayText")
  }

  new iPlayers[32], iPlayersNum, iPlayer
  get_players(iPlayers, iPlayersNum, "ac")

  for(new i = 0; i < iPlayersNum; i++) {
    iPlayer = iPlayers[i]
    format_args(szMessage[1], sizeof(szMessage) - 2, 0, iPlayer)
    message_begin(MSG_ONE_UNRELIABLE, iMsgIdSayText, _, iPlayer)
    write_byte(iPlayer)
    write_string(szMessage)
    message_end()
  }
}
